{$M 64000,0,655360}

program sort;

uses crt;

const escape= #27;

type item   = record
                key : integer;
                { Ino }
              end;

     itemfeld = array [0..10000] of item;
     str20    = string [20];

var s       :  itemfeld;
    sortwahl:  char;
    n,b,v,o:longint;

{----------------------------------------------------------------------------}
{ Auswahl des Sortieralgorithmus und Erzeugung der zu sortierenden Elemente  }
{----------------------------------------------------------------------------}

procedure auswahl (var ch: char);

var art: char;
    k  : integer;

begin
  clrscr;
  lowvideo;
  gotoxy(28,1); write('                    ');
  gotoxy(28,2); write(' Sortieralgorithmen ');
  gotoxy(28,3); write('                    ');
  normvideo;
  gotoxy(12,4);
  writeln(' Anzahl  der  zu  sortierenden  Elemente ');
  gotoxy(12,5);
  write  (' ( n <= 10000, Felder-Ausgabe bis n=200): ');
  readln(n);
  gotoxy(12,7);
  write('<1> - Einfuegsort,  <2> - Shellsort,  <3> - Quicksort     ');
  repeat
    ch:=readkey;
  until ch in ['1'..'3'];
  write(ch);
  gotoxy(12,9);
  write('<1> - sortiert,     <2> - zufaellig,  <3> - umgekehrt     ');
  repeat
    art:=readkey;
  until art in ['1'..'3'];
  write(art);
  case art of
    '1': for k:=1 to n do s[k].key:=k;
    '2': for k:=1 to n do s[k].key:=trunc(random*1000);
    '3': for k:=1 to n do s[n-k+1].key:=k;
  end;
  clrscr;
end;



{----------------------------------------------------------------------------}
{------------Vertauschen zweier Lisenelemente s[i] und s[j] ----------------}
{----------------------------------------------------------------------------}

procedure tausche(i,j:integer);

var h : item;

begin
  h:=s[i]; s[i]:=s[j]; s[j]:=h;
end;



{----------------------------------------------------------------------------}
{----------Ausgabe der unsortierten und der sortierten Liste-----------------}
{---------------------------------------------------------------------------}

procedure schreibe(wort:str20);

var i:integer;

begin
  if n <= 200 then
    begin
      lowvideo; writeln(wort); normvideo;
      for i:=1 to n do
      begin
        write(s[i].key:4);
        if i mod 19 = 0 then writeln;
      end;
    end;
end;



{----------------------------------------------------------------------------}
{----------------------------E I N F  G E S O R T---------------------------}
{----------------Sortieren durch Einfgen mit gesetzter Marke----------------}
{----------------------------------------------------------------------------}

procedure einfuegesort(n:integer);

var i,j : integer;
    h   : item;

begin
  for i:=2 to n do
    begin
      inc(o);
      j:=i-1; h:=s[i]; s[0]:=h;   { aktuelles Element festhalten (h)   }
                                  { Hilfselement = aktuelles Element,  }
                                  { stellt Abbruch der Schleife sicher }
      inc(o,2);
      inc(b);
      inc(v);
      while h.key < s[j].key do
        begin
          s[j+1]:=s[j]; j:=j-1;   { grere Elemente nach rechts schieben }
          inc(o);
          inc(v);
          inc(b);
        end;
      s[j+1]:=h;
      inc(b);
    end;
end;



{----------------------------------------------------------------------------}
{--------------------------- S H E L L S O R T ------------------------------}
{ Sortieren durch Einfgen mit variabler Schrittweite.                       }
{ Die Schrittweiten werden nach folgender Formel berechnet :                 }
{                                                                            }
{ h(t) = 1,  h(k-1) = 2 * h(k) + 1      fr k von t bis 2                    }
{                                                                            }
{ t ist die Anzahl der Schrittweiten und wird berechnet nach der Formel      }
{ t = trunc(log2n) -1      (Knuth)                                           }
{----------------------------------------------------------------------------}

procedure shellsort(links,rechts : integer);

var i,j,t,schritt : integer;

begin
  t:=trunc(ln(n)/ln(2))-1; schritt:=1;             { Schrittweite ermitteln }
  inc(o,2);
  for i:=2 to t do
  begin
    inc(o,2);
    schritt := 2*schritt+1;
  end;
  repeat
    j:=1;
    inc(o);
    repeat
      i:=j;
      inc(o);
      inc(v);
      while (i+schritt <= rechts) and (i>=1) and (s[i].key>s[i+schritt].key) do
        begin
          tausche(i, i+schritt);
          inc(b,2);
          inc(o);
          i:=i - schritt;
          inc(o);
          inc(v);
        end;
      j := j+1;
      inc(o);
    until (j + schritt) > rechts;
    schritt := schritt div 2;
    inc(o);
  until schritt = 0;
end;



{-----------------------------------------------------------------------------}
{-------------------------- Q U I C K S O R T -------------------------------}
{ Zerlegen in zwei Teillisten durch Wahl des mittleren Elementes als          }
{ Vergleichselement un Austausch aller Elemente der Teillisten, die grer   }
{ bzw. kleiner als das Vergleichselement sind. Rekursive Anwendung des        }
{ Verfahrens auf die verbleibenden Listen, bis sie nur noch ein Element       }
{ enthalten. Dann ist die gesamte Liste sortiert.                             }
{-----------------------------------------------------------------------------}

procedure quicksort(l,r : integer);

var i,j,x: integer;

begin
  i:=l; j:=r;
  x:=s[(l+r) div 2].key;                  { Vergleichelement ermitteln }
  inc(o,3);
  repeat
    inc(v);
    while s[i].key < x do
    begin
      i := i+1;       { links  greres  Element suchen }
      inc(v);
      inc(o);
    end;
    inc(v);
    while x < s[j].key do
    begin
      j:=j-1;         { rechts kleineres Element suchen }
      inc(v);
      inc(o);
    end;
    inc(o);
    if i <= j then
      begin
        tausche(i,j); i:=i+1; j:=j-1;     { falls vorhanden, austauschen }
        inc(b,2);
        inc(o,3);
      end;
    inc(o);
  until i > j;
  if l < j then quicksort(l,j);           { Anwendung des Verfahrens auf die }
  if i < r then quicksort(i,r);           { beiden Teillisten                }
  inc(o,2);
end;



{----------------------------------------------------------------------------}
{----------------------------- Hauptprogramm --------------------------------}
{----------------------------------------------------------------------------}

begin
  repeat
    b:=0;
    v:=0;
    o:=0;
    auswahl(sortwahl);
    schreibe('   Eingabe :  ');
    case sortwahl of
      '1': einfuegesort(n);
      '2': shellsort(1,n);
      '3': quicksort(1,n);
    end;
    writeln;
    schreibe('   Ausgabe :  ');              { Ausgabe der sortierten Liste }
    writeln;
    writeln(v,' Vergleiche und ',b,' Bewegungen. Auerdem ',o,' zustzliche Operationen.');
    writeln; lowvideo; write('beenden mit ESC ');
    normvideo;
    sortwahl:=readkey;
  until sortwahl = escape;
end.
